package de.hft.stuttgart.citydoctor2.gui;

import java.io.PrintWriter;
import java.io.StringWriter;

import de.hft.stuttgart.citydoctor2.utils.Localization;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Priority;

public class ExceptionDialog {
	
	private Alert alert;
	
	private TextArea textArea;
	
	public ExceptionDialog() {
		alert = new Alert(AlertType.ERROR);
		alert.setTitle("Exception Dialog");
		alert.getDialogPane().setPrefWidth(800);
		Label label = new Label(Localization.getText("ExceptionDialog.stacktrace"));

		textArea = new TextArea();
		textArea.setEditable(false);
		textArea.setWrapText(true);

		textArea.setMaxWidth(Double.MAX_VALUE);
		textArea.setMaxHeight(Double.MAX_VALUE);
		GridPane.setVgrow(textArea, Priority.ALWAYS);
		GridPane.setHgrow(textArea, Priority.ALWAYS);

		GridPane expContent = new GridPane();
		expContent.setMaxWidth(Double.MAX_VALUE);
		expContent.add(label, 0, 0);
		expContent.add(textArea, 0, 1);

		// Set expandable Exception into the dialog pane.
		alert.getDialogPane().setExpandableContent(expContent);
	}
	
	public void show(Throwable ex) {
		// Create expandable Exception.
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		ex.printStackTrace(pw);
		String exceptionText = sw.toString();
		textArea.setText(exceptionText);
		alert.setContentText(ex.getMessage());
		alert.setHeaderText(ex.getClass().getSimpleName());
		alert.showAndWait();
	}

}
